"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.typedTopic = exports.typedCaller = void 0;
const pubsub_1 = require("@google-cloud/pubsub");
const functions_1 = require("firebase/functions");
const index_js_1 = require("../../index.js");
const _app_js_1 = require("./_app.js");
const _config_js_1 = require("./_config.js");
const functionsApp = (0, _app_js_1.getTestAppWeb)('user').functions('asia-northeast1');
(0, functions_1.connectFunctionsEmulator)(functionsApp, _config_js_1.localhost, _config_js_1.emulatorConfig.functions.port);
exports.typedCaller = new index_js_1.TypedCaller(functionsApp);
exports.typedTopic = new index_js_1.TypedTopic(new pubsub_1.PubSub({
    apiEndpoint: `http://${_config_js_1.localhost}:${_config_js_1.emulatorConfig.pubsub.port}`,
    projectId: _config_js_1.projectId,
}));
