"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useTypedDocument = exports.useTypedDocumentOnce = void 0;
const firestore_1 = require("react-firebase-hooks/firestore");
const useSnapData_js_1 = require("./useSnapData.js");
const utils_js_1 = require("./utils.js");
const useTypedDocumentOnce = (typedDoc, { getOptions, ...dataOptions } = {}) => {
    const { safeRef, refChanged } = (0, utils_js_1.useSafeRef)(typedDoc === null || typedDoc === void 0 ? void 0 : typedDoc.raw);
    const [_snap, _loading, error] = (0, firestore_1.useDocumentOnce)(safeRef, {
        getOptions,
    });
    const loading = _loading || refChanged;
    (0, utils_js_1.useFirestoreErrorLogger)(error);
    const { snap, data } = (0, useSnapData_js_1.useDocumentSnapData)(typedDoc, _snap, dataOptions);
    return { snap, data, loading, error };
};
exports.useTypedDocumentOnce = useTypedDocumentOnce;
const useTypedDocument = (typedDoc, { snapshotListenOptions, ...dataOptions } = {}) => {
    const { safeRef, refChanged } = (0, utils_js_1.useSafeRef)(typedDoc === null || typedDoc === void 0 ? void 0 : typedDoc.raw);
    const [_snap, _loading, error] = (0, firestore_1.useDocument)(safeRef, {
        snapshotListenOptions,
    });
    const loading = _loading || refChanged;
    (0, utils_js_1.useFirestoreErrorLogger)(error);
    const { snap, data } = (0, useSnapData_js_1.useDocumentSnapData)(typedDoc, _snap, dataOptions);
    return { snap, data, loading, error };
};
exports.useTypedDocument = useTypedDocument;
