import React from 'react';
import { useTypedDocument, useTypedQuery } from '../hooks/index.js';
import { typedFirestore } from './1-3-typed-firestore.js';
/**
 * Get realtime updates of collection/query
 */
export const UsersComponent = () => {
    const users = useTypedQuery(typedFirestore.collection('users'));
    if (!users.data) {
        return React.createElement("span", null, 'Loading...');
    }
    return (React.createElement("ul", null, users.data.map((user, i) => (React.createElement("li", { key: i }, user.displayName)))));
};
/**
 * Get realtime updates of document
 */
export const UserComponent = ({ id }) => {
    const user = useTypedDocument(typedFirestore.collection('users').doc(id));
    if (!user.data) {
        return React.createElement("span", null, 'Loading...');
    }
    return React.createElement("span", null, user.data.displayName);
};
