import { useMemo } from 'react';
import { TypedDocumentSnap, TypedQuerySnap, } from '../core/index.js';
export const useDocumentSnapData = (typedDoc, _snap, { transformer, snapshotOptions, } = {}) => {
    const snap = useMemo(() => typedDoc && _snap
        ? new TypedDocumentSnap(typedDoc.options, _snap)
        : undefined, 
    // eslint-disable-next-line react-hooks/exhaustive-deps
    [_snap]);
    const data = useMemo(() => snap === null || snap === void 0 ? void 0 : snap.data({
        transformer,
        snapshotOptions: {
            serverTimestamps: 'estimate',
            ...snapshotOptions,
        },
    }), 
    // eslint-disable-next-line react-hooks/exhaustive-deps
    [snap]);
    return { snap, data };
};
export const useQuerySnapData = (typedQuery, _snap, { transformer, snapshotOptions, }) => {
    const snap = useMemo(() => typedQuery && _snap
        ? new TypedQuerySnap(typedQuery.options, _snap)
        : undefined, 
    // eslint-disable-next-line react-hooks/exhaustive-deps
    [_snap]);
    const data = useMemo(() => snap === null || snap === void 0 ? void 0 : snap.typedDocs.map((docSnap) => docSnap.data({
        transformer,
        snapshotOptions: {
            serverTimestamps: 'estimate',
            ...snapshotOptions,
        },
    })), 
    // eslint-disable-next-line react-hooks/exhaustive-deps
    [snap]);
    return { snap, data };
};
