import { useCollection, useCollectionOnce, } from 'react-firebase-hooks/firestore';
import { useQuerySnapData } from './useSnapData.js';
import { useFirestoreErrorLogger, useSafeRef } from './utils.js';
export const useTypedQueryOnce = (typedQuery, { getOptions, ...dataOptions } = {}) => {
    const { safeRef, refChanged } = useSafeRef(typedQuery === null || typedQuery === void 0 ? void 0 : typedQuery.raw);
    const [_snap, _loading, error] = useCollectionOnce(safeRef, {
        getOptions,
    });
    const loading = _loading || refChanged;
    useFirestoreErrorLogger(error);
    const { snap, data } = useQuerySnapData(typedQuery, _snap, dataOptions);
    return { snap, data, loading, error };
};
export const useTypedQuery = (typedQuery, { snapshotListenOptions, ...dataOptions } = {}) => {
    const { safeRef, refChanged } = useSafeRef(typedQuery === null || typedQuery === void 0 ? void 0 : typedQuery.raw);
    const [_snap, _loading, error] = useCollection(safeRef, {
        snapshotListenOptions,
    });
    const loading = _loading || refChanged;
    useFirestoreErrorLogger(error);
    const { snap, data } = useQuerySnapData(typedQuery, _snap, dataOptions);
    return { snap, data, loading, error };
};
