import dayjs from 'dayjs';
import { CollectionReference, DocumentReference, Query } from 'firebase/firestore';
import { _web } from '../lib/firestore-types.js';
declare type RefOrQuery = DocumentReference | CollectionReference | Query;
export declare const useSafeRef: <T extends RefOrQuery>(ref: T | undefined) => {
    safeRef: T | undefined;
    refChanged: boolean;
    timestamps: import("react").MutableRefObject<dayjs.Dayjs[]>;
};
export declare const useFirestoreErrorLogger: (error: _web.FirestoreError | undefined) => void;
export {};
